; MOS6526

.define CIA1_BASE $dc00

.define CIA_PIO0          %00000001
.define CIA_PIO1          %00000010
.define CIA_PIO2          %00000100
.define CIA_PIO3          %00001000
.define CIA_PIO4          %00010000
.define CIA_PIO5          %00100000
.define CIA_PIO6          %01000000
.define CIA_PIO7          %10000000

.define CIA1_PRA          CIA1_BASE+$00; Port register A
 .define KBD_COLUMN0      CIA_PIO0^$ff
 .define KBD_COLUMN1      CIA_PIO1^$ff
 .define KBD_COLUMN2      CIA_PIO2^$ff
 .define KBD_COLUMN3      CIA_PIO3^$ff
 .define KBD_COLUMN4      CIA_PIO4^$ff
 .define KBD_COLUMN5      CIA_PIO4^$ff
 .define KBD_COLUMN6      CIA_PIO5^$ff
 .define KBD_COLUMN7      CIA_PIO5^$ff

 .define JOY1_UP          CIA_PIO0^$ff
 .define JOY1_DOWN        CIA_PIO1^$ff
 .define JOY1_LEFT        CIA_PIO2^$ff
 .define JOY1_RIGHT       CIA_PIO3^$ff
 .define JOY1_FIRE        CIA_PIO4^$ff

 .define PADDLE_ENPORT1   CIA_PIO6
 .define PADDLE_ENPORT2   CIA_PIO7
 .define PADDLE_EN_MASK   CIA_PIO5|CIA_PIO4|CIA_PIO3|CIA_PIO2|CIA_PIO1|CIA_PIO0

.define CIA1_PRB          CIA1_BASE+$01; Port register B
 .define KBD_ROW0         CIA_PIO0^$ff
 .define KBD_ROW1         CIA_PIO1^$ff
 .define KBD_ROW2         CIA_PIO2^$ff
 .define KBD_ROW3         CIA_PIO3^$ff
 .define KBD_ROW4         CIA_PIO4^$ff
 .define KBD_ROW5         CIA_PIO5^$ff
 .define KBD_ROW6         CIA_PIO6^$ff
 .define KBD_ROW7         CIA_PIO7^$ff

 .define JOY2_UP          CIA_PIO0^$ff
 .define JOY2_DOWN        CIA_PIO1^$ff
 .define JOY2_LEFT        CIA_PIO2^$ff
 .define JOY2_RIGHT       CIA_PIO3^$ff
 .define JOY2_FIRE        CIA_PIO4^$ff

.define CIA1_DDRA         CIA1_BASE+$02; Data direction register A
 .define CIA_PIO0_OUTPUT  CIA_PIO0
 .define CIA_PIO0_INPUT   %00000000
 .define CIA_PIO1_OUTPUT  CIA_PIO1
 .define CIA_PIO1_INPUT   %00000000
 .define CIA_PIO2_OUTPUT  CIA_PIO2
 .define CIA_PIO2_INPUT   %00000000
 .define CIA_PIO3_OUTPUT  CIA_PIO3
 .define CIA_PIO3_INPUT   %00000000
 .define CIA_PIO4_OUTPUT  CIA_PIO4
 .define CIA_PIO4_INPUT   %00000000
 .define CIA_PIO5_OUTPUT  CIA_PIO5
 .define CIA_PIO5_INPUT   %00000000
 .define CIA_PIO6_OUTPUT  CIA_PIO6
 .define CIA_PIO6_INPUT   %00000000
 .define CIA_PIO7_OUTPUT  CIA_PIO7
 .define CIA_PIO7_INPUT   %00000000

.define CIA1_DDRB         CIA1_BASE+$03; Data direction register B

.define CIA1_TA_LO        CIA1_BASE+$04; Timer A, low byte
.define CIA1_TA_HI        CIA1_BASE+$05; Timer A, high byte
.define CIA1_TB_LO        CIA1_BASE+$06; Timer B, low byte
.define CIA1_TB_HI        CIA1_BASE+$07; Timer B, high byte

.define CIA1_TOD_10S      CIA1_BASE+$08; Time of day, 1/10 seconds
.define CIA1_TOD_SEC      CIA1_BASE+$09; Time of day, seconds
.define CIA1_TOD_MIN      CIA1_BASE+$0a; Time of day, minutes
.define CIA1_TOD_HRS      CIA1_BASE+$0b; Time of day, hours
 .define TOD_AM           %00000000
 .define TOD_PM           %10000000
 .define TOD_AMPM_MASK    %10000000
 .define TOD_HRS_MASK     %00011111

.define CIA1_SDR          CIA1_BASE+$0c; Serial data register

.define CIA1_ICR          CIA1_BASE+$0d; Interrupt control register
 .define TIMERA_IRQ       %00000001
 .define TIMERB_IRQ       %00000010
 .define TOD_IRQ          %00000100
 .define SERIAL_IRQ       %00001000   
 .define FLAG1_IRQ        %00010000
 .define CIA_INTERRUPT    %10000000
 .define CIA_CLR_INTF     %00000000
 .define CIA_SET_INTF     %10000000

.define CIA1_CRA          CIA1_BASE+$0e; Control Register A
 .define TIMER_STOP       %00000000
 .define TIMER_START      %00000001
 .define OUTPUT_TO_PB6    %00000010
 .define OUTPUT_PULSE     %00000000
 .define OUTPUT_TOGGLE    %00000100
 .define ONE_CONTINUOUS   %00000000
 .define ONE_SHOT         %00001000
 .define FORCE_LOAD       %00010000
 .define COUNT_PHI2       %00000000
 .define COUNT_CNT        %00100000
 .define IOMODE_INPUT     %00000000
 .define IOMODE_OUTPUT    %01000000
 .define TOD_FREQ_60HZ    %00000000
 .define TOD_FREQ_50HZ    %10000000

.define CIA1_CRB          CIA1_BASE+$0f; Control Register B
;.define TIMER_STOP       %00000000
;.define TIMER_START      %00000001
 .define OUTPUT_TO_PB7    %00000010
;.define OUTPUT_PULSE     %00000000
;.define OUTPUT_TOGGLE    %00000100
;.define ONE_CONTINUOUS   %00000000
;.define ONE_SHOT         %00001000
;.define FORCE_LOAD       %00010000
;.define COUNT_PHI2       %00000000
 .define COUNT_CNT_POS    %00100000
 .define COUNT_TA_UNDF    %01000000
 .define COUNT_TA_UFCN    %01100000
 .define TOD_SET_CLOCK    %00000000
 .define TOD_SET_ALARM    %10000000
 
.define CIA2_BASE $dd00

.define CIA2_PRA          CIA2_BASE+$00; Port register A
 .define VIC2_BANK0       %00000000
 .define VIC2_BANK1       CIA_PIO0
 .define VIC2_BANK2       CIA_PIO1
 .define VIC2_BANK3       CIA_PIO1|CIA_PIO0
 .define RS232_OUT        CIA_PIO2
 .define SERIAL_ATN_OUT   CIA_PIO3
 .define SERIAL_CLK_OUT   CIA_PIO4
 .define SERIAL_DAT_OUT   CIA_PIO5
 .define SERIAL_CLK_IN    CIA_PIO6
 .define SERIAL_DAT_IN    CIA_PIO7

.define CIA2_PRB          CIA2_BASE+$01; Port register B
 .define RS232_RXD        CIA_PIO0
 .define RS232_RTS        CIA_PIO1
 .define RS232_DTR        CIA_PIO2
 .define RS232_RING       CIA_PIO3
 .define RS232_CARRIER    CIA_PIO4
 .define USERPORT_PB5     CIA_PIO5
 .define RS232_CTS        CIA_PIO6
 .define Rs232_DSR        CIA_PIO7

.define CIA2_DDRA         CIA2_BASE+$02; Data direction register A
;.define CIA_PIO0_OUTPUT  CIA_PIO0
;.define CIA_PIO0_INPUT   %00000000
;.define CIA_PIO1_OUTPUT  CIA_PIO1
;.define CIA_PIO1_INPUT   %00000000
;.define CIA_PIO2_OUTPUT  CIA_PIO2
;.define CIA_PIO2_INPUT   %00000000
;.define CIA_PIO3_OUTPUT  CIA_PIO3
;.define CIA_PIO3_INPUT   %00000000
;.define CIA_PIO4_OUTPUT  CIA_PIO4
;.define CIA_PIO4_INPUT   %00000000
;.define CIA_PIO5_OUTPUT  CIA_PIO5
;.define CIA_PIO5_INPUT   %00000000
;.define CIA_PIO6_OUTPUT  CIA_PIO6
;.define CIA_PIO6_INPUT   %00000000
;.define CIA_PIO7_OUTPUT  CIA_PIO7
;.define CIA_PIO7_INPUT   %00000000

.define CIA2_DDRB         CIA2_BASE+$03; Data direction register B

.define CIA2_TA_LO        CIA2_BASE+$04; Timer A, low byte
.define CIA2_TA_HI        CIA2_BASE+$05; Timer A, high byte
.define CIA2_TB_LO        CIA2_BASE+$06; Timer B, low byte
.define CIA2_TB_HI        CIA2_BASE+$07; Timer B, high byte

.define CIA2_TOD_10S      CIA2_BASE+$08; Time of day, 1/10 seconds
.define CIA2_TOD_SEC      CIA2_BASE+$09; Time of day, seconds
.define CIA2_TOD_MIN      CIA2_BASE+$0a; Time of day, minutes
.define CIA2_TOD_HRS      CIA2_BASE+$0b; Time of day, hours
;.define TOD_PM           %10000000
;.define TOD_HRS_MASK     %00011111

.define CIA2_SDR          CIA2_BASE+$0c; Serial data register

.define CIA2_ICR          CIA2_BASE+$0d; Interrupt control register
;.define TIMERA_IRQ       %00000001
;.define TIMERB_IRQ       %00000010
;.define TOD_IRQ          %00000100
;.define SERIAL_IRQ       %00001000   
;.define FLAG1_IRQ        %00010000
;.define CIA_INTERRUPT    %10000000
;.define CIA_CLR_INTF     %00000000
;.define CIA_SET_INTF     %10000000
   
.define CIA2_CRA          CIA2_BASE+$0e; Control Register A
;.define TIMER_STOP       %00000000
;.define TIMER_START      %00000001
;.define OUTPUT_TO_PB6    %00000010
;.define OUTPUT_PULSE     %00000000
;.define OUTPUT_TOGGLE    %00000100
;.define ONE_CONTINUOUS   %00000000
;.define ONE_SHOT         %00001000
;.define FORCE_LOAD       %00010000
;.define COUNT_PHI2       %00000000
;.define COUNT_CNT        %00100000
 .define SERIAL_INPUT     %00000000
 .define SERIAL_OUTPUT    %01000000
;.define TOD_FREQ_60HZ    %00000000
;.define TOD_FREQ_50HZ    %10000000

.define CIA2_CRB          CIA2_BASE+$0f; Control Register B
;.define TIMER_STOP       %00000000
;.define TIMER_START      %00000001
;.define OUTPUT_TO_PB7    %00000010
;.define OUTPUT_PULSE     %00000000
;.define OUTPUT_TOGGLE    %00000100
;.define ONE_CONTINUOUS   %00000000
;.define ONE_SHOT         %00001000
;.define FORCE_LOAD       %00010000
;.define COUNT_PHI2       %00000000
;.define COUNT_CNT_POS    %00100000
;.define COUNT_TA_UNDF    %01000000
;.define COUNT_TA_UFCN    %01100000
;.define TOD_SET_CLOCK    %00000000
;.define TOD_SET_ALARM    %10000000
