; MOS6581/MO8580

.ifndef _SID_INC_
.define _SID_INC_

; broken due to 16-bit maths in ca65
;.define FREQUENCY_PAL(reg_value)  (reg_value*CLOCK_PAL/16777216)
;.define SID_FREQVAL_PAL(hz)       (16777216*hz/CLOCK_PAL)
;.define FREQUENCY_NTSC(reg_value) (reg_value*CLOCK_NTSC/16777216)
;.define SID_FREQVAL_NTSC(hz)      (16777216*hz/CLOCK_NTSC)

.define SID_BASE                $d400

; voice 1
.define SID_V1_FREQ_LO          SID_BASE+$00
.define SID_V1_FREQ_HI          SID_BASE+$01
.define SID_V1_PULSE_LO         SID_BASE+$02
.define SID_V1_PULSE_HI         SID_BASE+$03
.define SID_V1_CONTROL          SID_BASE+$04
 .define NOISE                  %10000000
 .define PULSE                  %01000000
 .define SAWTOOTH               %00100000
 .define TRIANGLE               %00010000
 .define WAVE_RESET             %00001000
 .define RING_MOD               %00000100
 .define SYNC_OSC               %00000010
 .define GATE_BIT               %00000001
 .define GATE                   GATE_BIT
.define SID_V1_AD               SID_BASE+$05
 .define ATTACK_0               %00000000
 .define ATTACK_1               %00010000
 .define ATTACK_2               %00100000
 .define ATTACK_3               %00110000
 .define ATTACK_4               %01000000
 .define ATTACK_5               %01010000
 .define ATTACK_6               %01100000
 .define ATTACK_7               %01110000
 .define ATTACK_8               %10000000
 .define ATTACK_9               %10010000
 .define ATTACK_10              %10100000
 .define ATTACK_11              %10110000
 .define ATTACK_12              %11000000
 .define ATTACK_13              %11010000
 .define ATTACK_14              %11100000
 .define ATTACK_15              %11110000
 .define ATTACK_MIN             ATTACK_0
 .define ATTACK_MAX             ATTACK_15
 .define ATTACK_MASK            %11110000
 .define ATTACK_SHIFT           0
 .define DECAY_0                %00000000
 .define DECAY_1                %00000001
 .define DECAY_2                %00000010
 .define DECAY_3                %00000011
 .define DECAY_4                %00000100
 .define DECAY_5                %00000101
 .define DECAY_6                %00000110
 .define DECAY_7                %00000111
 .define DECAY_8                %00001000
 .define DECAY_9                %00001001
 .define DECAY_10               %00001010
 .define DECAY_11               %00001011
 .define DECAY_12               %00001100
 .define DECAY_13               %00001101
 .define DECAY_14               %00001110
 .define DECAY_15               %00001111
 .define DECAY_MIN              DECAY_0
 .define DECAY_MAX              DECAY_15
 .define DECAY_MASK             %00001111
 .define DECAY_SHIFT            4
.define SID_V1_SR               SID_BASE+$06
 .define SUSTAIN_0              %00000000
 .define SUSTAIN_1              %00010000
 .define SUSTAIN_2              %00100000
 .define SUSTAIN_3              %00110000
 .define SUSTAIN_4              %01000000
 .define SUSTAIN_5              %01010000
 .define SUSTAIN_6              %01100000
 .define SUSTAIN_7              %01110000
 .define SUSTAIN_8              %10000000
 .define SUSTAIN_9              %10010000
 .define SUSTAIN_10             %10100000
 .define SUSTAIN_11             %10110000
 .define SUSTAIN_12             %11000000
 .define SUSTAIN_13             %11010000
 .define SUSTAIN_14             %11100000
 .define SUSTAIN_15             %11110000
 .define SUSTAIN_MIN            SUSTAIN_0
 .define SUSTAIN_MAX            SUSTAIN_15
 .define SUSTAIN_MASK           %11110000
 .define SUSTAIN_SHIFT          0
 .define RELEASE_0              %00000000
 .define RELEASE_1              %00000001
 .define RELEASE_2              %00000010
 .define RELEASE_3              %00000011
 .define RELEASE_4              %00000100
 .define RELEASE_5              %00000101
 .define RELEASE_6              %00000110
 .define RELEASE_7              %00000111
 .define RELEASE_8              %00001000
 .define RELEASE_9              %00001001
 .define RELEASE_10             %00001010
 .define RELEASE_11             %00001011
 .define RELEASE_12             %00001100
 .define RELEASE_13             %00001101
 .define RELEASE_14             %00001110
 .define RELEASE_15             %00001111
 .define RELEASE_MIN            RELEASE_0
 .define RELEASE_MAX            RELEASE_15
 .define RELEASE_MASK           %00001111
 .define RELEASE_SHIFT          4

; voice 2
.define SID_V2_FREQ_LO          SID_BASE+$07
.define SID_V2_FREQ_HI          SID_BASE+$08
.define SID_V2_PULSE_LO         SID_BASE+$09
.define SID_V2_PULSE_HI         SID_BASE+$0a
.define SID_V2_CONTROL          SID_BASE+$0b
;.define NOISE                  %10000000
;.define PULSE                  %01000000
;.define SAWTOOTH               %00100000
;.define TRIANGLE               %00010000
;.define TESTBIT                %00001000
;.define RING_MOD               %00000100
;.define SYNC_OSC               %00000010
;.define GATE_BIT               %00000001
.define SID_V2_AD               SID_BASE+$0c
;.define ATTACK_0               %00000000
;.define ATTACK_1               %00010000
;.define ATTACK_2               %00100000
;.define ATTACK_3               %00110000
;.define ATTACK_4               %01000000
;.define ATTACK_5               %01010000
;.define ATTACK_6               %01100000
;.define ATTACK_7               %01110000
;.define ATTACK_8               %10000000
;.define ATTACK_9               %10010000
;.define ATTACK_10              %10100000
;.define ATTACK_11              %10110000
;.define ATTACK_12              %11000000
;.define ATTACK_13              %11010000
;.define ATTACK_14              %11100000
;.define ATTACK_15              %11110000
;.define ATTACK_MIN             ATTACK_0
;.define ATTACK_MAX             ATTACK_15
;.define ATTACK_MASK            %11110000
;.define ATTACK_SHIFT           0
;.define DECAY_0                %00000000
;.define DECAY_1                %00000001
;.define DECAY_2                %00000010
;.define DECAY_3                %00000011
;.define DECAY_4                %00000100
;.define DECAY_5                %00000101
;.define DECAY_6                %00000110
;.define DECAY_7                %00000111
;.define DECAY_8                %00001000
;.define DECAY_9                %00001001
;.define DECAY_10               %00001010
;.define DECAY_11               %00001011
;.define DECAY_12               %00001100
;.define DECAY_13               %00001101
;.define DECAY_14               %00001110
;.define DECAY_15               %00001111
;.define DECAY_MIN              DECAY_0
;.define DECAY_MAX              DECAY_15
;.define DECAY_MASK             %00001111
;.define DECAY_SHIFT            4
.define SID_V2_SR               SID_BASE+$0d
;.define SUSTAIN_0              %00000000
;.define SUSTAIN_1              %00010000
;.define SUSTAIN_2              %00100000
;.define SUSTAIN_3              %00110000
;.define SUSTAIN_4              %01000000
;.define SUSTAIN_5              %01010000
;.define SUSTAIN_6              %01100000
;.define SUSTAIN_7              %01110000
;.define SUSTAIN_8              %10000000
;.define SUSTAIN_9              %10010000
;.define SUSTAIN_10             %10100000
;.define SUSTAIN_11             %10110000
;.define SUSTAIN_12             %11000000
;.define SUSTAIN_13             %11010000
;.define SUSTAIN_14             %11100000
;.define SUSTAIN_15             %11110000
;.define SUSTAIN_MIN            SUSTAIN_0
;.define SUSTAIN_MAX            SUSTAIN_15
;.define SUSTAIN_MASK           %11110000
;.define SUSTAIN_SHIFT          0
;.define RELEASE_0              %00000000
;.define RELEASE_1              %00000001
;.define RELEASE_2              %00000010
;.define RELEASE_3              %00000011
;.define RELEASE_4              %00000100
;.define RELEASE_5              %00000101
;.define RELEASE_6              %00000110
;.define RELEASE_7              %00000111
;.define RELEASE_8              %00001000
;.define RELEASE_9              %00001001
;.define RELEASE_10             %00001010
;.define RELEASE_11             %00001011
;.define RELEASE_12             %00001100
;.define RELEASE_13             %00001101
;.define RELEASE_14             %00001110
;.define RELEASE_15             %00001111
;.define RELEASE_MIN            RELEASE_0
;.define RELEASE_MAX            RELEASE_15
;.define RELEASE_MASK           %00001111
;.define RELEASE_SHIFT          4

; voice 3
.define SID_V3_FREQ_LO          SID_BASE+$0e
.define SID_V3_FREQ_HI          SID_BASE+$0f
.define SID_V3_PULSE_LO         SID_BASE+$10
.define SID_V3_PULSE_HI         SID_BASE+$11
.define SID_V3_CONTROL          SID_BASE+$12
;.define NOISE                  %10000000
;.define PULSE                  %01000000
;.define SAWTOOTH               %00100000
;.define TRIANGLE               %00010000
;.define TESTBIT                %00001000
;.define RING_MOD               %00000100
;.define SYNC_OSC               %00000010
;.define GATE_BIT               %00000001
.define SID_V3_AD               SID_BASE+$13
;.define ATTACK_0               %00000000
;.define ATTACK_1               %00010000
;.define ATTACK_2               %00100000
;.define ATTACK_3               %00110000
;.define ATTACK_4               %01000000
;.define ATTACK_5               %01010000
;.define ATTACK_6               %01100000
;.define ATTACK_7               %01110000
;.define ATTACK_8               %10000000
;.define ATTACK_9               %10010000
;.define ATTACK_10              %10100000
;.define ATTACK_11              %10110000
;.define ATTACK_12              %11000000
;.define ATTACK_13              %11010000
;.define ATTACK_14              %11100000
;.define ATTACK_15              %11110000
;.define ATTACK_MIN             ATTACK_0
;.define ATTACK_MAX             ATTACK_15
;.define ATTACK_MASK            %11110000
;.define ATTACK_SHIFT           0
;.define DECAY_0                %00000000
;.define DECAY_1                %00000001
;.define DECAY_2                %00000010
;.define DECAY_3                %00000011
;.define DECAY_4                %00000100
;.define DECAY_5                %00000101
;.define DECAY_6                %00000110
;.define DECAY_7                %00000111
;.define DECAY_8                %00001000
;.define DECAY_9                %00001001
;.define DECAY_10               %00001010
;.define DECAY_11               %00001011
;.define DECAY_12               %00001100
;.define DECAY_13               %00001101
;.define DECAY_14               %00001110
;.define DECAY_15               %00001111
;.define DECAY_MIN              DECAY_0
;.define DECAY_MAX              DECAY_15
;.define DECAY_MASK             %00001111
;.define DECAY_SHIFT            4
.define SID_V3_SR               SID_BASE+$14
;.define SUSTAIN_0              %00000000
;.define SUSTAIN_1              %00010000
;.define SUSTAIN_2              %00100000
;.define SUSTAIN_3              %00110000
;.define SUSTAIN_4              %01000000
;.define SUSTAIN_5              %01010000
;.define SUSTAIN_6              %01100000
;.define SUSTAIN_7              %01110000
;.define SUSTAIN_8              %10000000
;.define SUSTAIN_9              %10010000
;.define SUSTAIN_10             %10100000
;.define SUSTAIN_11             %10110000
;.define SUSTAIN_12             %11000000
;.define SUSTAIN_13             %11010000
;.define SUSTAIN_14             %11100000
;.define SUSTAIN_15             %11110000
;.define SUSTAIN_MIN            SUSTAIN_0
;.define SUSTAIN_MAX            SUSTAIN_15
;.define SUSTAIN_MASK           %11110000
;.define SUSTAIN_SHIFT          0
;.define RELEASE_0              %00000000
;.define RELEASE_1              %00000001
;.define RELEASE_2              %00000010
;.define RELEASE_3              %00000011
;.define RELEASE_4              %00000100
;.define RELEASE_5              %00000101
;.define RELEASE_6              %00000110
;.define RELEASE_7              %00000111
;.define RELEASE_8              %00001000
;.define RELEASE_9              %00001001
;.define RELEASE_10             %00001010
;.define RELEASE_11             %00001011
;.define RELEASE_12             %00001100
;.define RELEASE_13             %00001101
;.define RELEASE_14             %00001110
;.define RELEASE_15             %00001111
;.define RELEASE_MIN            RELEASE_0
;.define RELEASE_MAX            RELEASE_15
;.define RELEASE_MASK           %00001111
;.define RELEASE_SHIFT          4

.define SID_FILTER_CUTOFF_LO    SID_BASE+$15
.define SID_FILTER_CUTOFF_HI    SID_BASE+$16
.define SID_FILTER_CONTROL_1    SID_BASE+$17
 .define FILTER_RESONANCE_0     %00000000
 .define FILTER_RESONANCE_1     %00010000
 .define FILTER_RESONANCE_2     %00100000
 .define FILTER_RESONANCE_3     %00110000
 .define FILTER_RESONANCE_4     %01000000
 .define FILTER_RESONANCE_5     %01010000
 .define FILTER_RESONANCE_6     %01100000
 .define FILTER_RESONANCE_7     %01110000
 .define FILTER_RESONANCE_8     %10000000
 .define FILTER_RESONANCE_9     %00010000
 .define FILTER_RESONANCE_10    %10100000
 .define FILTER_RESONANCE_11    %10110000
 .define FILTER_RESONANCE_12    %11000000
 .define FILTER_RESONANCE_13    %11010000
 .define FILTER_RESONANCE_14    %11100000
 .define FILTER_RESONANCE_15    %11110000
 .define FILTER_RESONANCE_MIN   FILTER_RESONANCE_0
 .define FILTER_RESONANCE_MAX   FILTER_RESONANCE_15
 .define FILTER_RESONANCE_MASK  %11110000
 .define FILTER_RESONANCE_SHIFT 4
 .define FILTER_AUX_IN          %00001000
 .define FILTER_VOICE_3         %00000100
 .define FILTER_VOICE_2         %00000010
 .define FILTER_VOICE_1         %00000001

.define SID_FILTER_CTRL2_VOL    SID_BASE+$18
.define SID_FILTER_CONTROL_2    SID_FILTER_CTRL2_VOL
.define SID_VOLUME              SID_FILTER_CTRL2_VOL
 .define CUT_OFF_VOICE_3        %10000000
 .define FILTER_HIGH_PASS       %01000000
 .define FILTER_BAND_PASS       %00100000
 .define FILTER_LOW_PASS        %00010000
 .define OUTPUT_VOLUME_0        %00000000
 .define OUTPUT_VOLUME_1        %00000001
 .define OUTPUT_VOLUME_2        %00000010
 .define OUTPUT_VOLUME_3        %00000011
 .define OUTPUT_VOLUME_4        %00000100
 .define OUTPUT_VOLUME_5        %00000101
 .define OUTPUT_VOLUME_6        %00000110
 .define OUTPUT_VOLUME_7        %00000111
 .define OUTPUT_VOLUME_8        %00001000
 .define OUTPUT_VOLUME_9        %00001001
 .define OUTPUT_VOLUME_10       %00001010
 .define OUTPUT_VOLUME_11       %00001011
 .define OUTPUT_VOLUME_12       %00001100
 .define OUTPUT_VOLUME_13       %00001101
 .define OUTPUT_VOLUME_14       %00001110
 .define OUTPUT_VOLUME_15       %00001111
 .define OUTPUT_VOLUME_MIN      OUTPUT_VOLUME_0
 .define OUTPUT_VOLUME_MAX      OUTPUT_VOLUME_15
 .define OUTPUT_VOLUME_MASK     %00001111
 .define OUTPUT_SAMPLE_MASK     %00001111
 .define OUTPUT_VOLUME_SHIFT    0
 
.define SID_PADDLE_1            SID_BASE+$19
.define PADDLE_1                SID_PADDLE_1
.define SID_PADDLE_2            SID_BASE+$1a
.define PADDLE_2                SID_PADDLE_2

.define SID_OSC3_OUTPUT         SID_BASE+$1a
.define SID_ENV3_OUTPUT         SID_BASE+$1b

.endif; !_SID_INC_
